//	V-USB AVR-HID/IO
//	wt]xH쎺	http://jsdiy.web.fc2.com

//ATmega88P
/*
y|[gΉz	ATmega88P	x:݂Ȃ(PC6RESET) -:
bit		7	6	5	4	3	2	1	0
portB	Xtl	Xtl	-	-	-	-	-	-		NX^
portC	x	x	-	-	-	-	-	-		--
portD	-	-	-	-	D+	D-	-	-		--

yATmega88Pz
|CCCCCC---BBBBB|
|543210GRV54321|
>              |
|601234VG675670|
|CDDDDD--BBDDDB|

yq[Yrbgz(ftavrw.exe -rf)	Hoאݒ Low:01100010(62), Hi:11011111(DF)
[vusb-20120109/examples/hid-data/firmware/Makefile]Q
Low: 11011111 (DF)
     ||||++++-- CKSEL[3:0] VXeNbNI
     ||++-- SUT[1:0] N
     |+-- CKOUT (0:PB0ɃVXeNbNo)
     +-- CKDIV8 NbNl (1:1/1, 0:1/8)

High:11-11110 (DE)
     |||||+++-- BODLEVEL[2:0] (111:, 110:1.8V, 101:2.7V, 100:4.3V)
     ||||+-- EESAVE (EEPROM 1:, 0:ێ)
     |||+-- WDTON (1:WDTʏ퓮, 0:WDT펞ON)
     ||+-- SPIEN (1:ISP֎~, 0:ISP) Parallel̂
     |+-- DWEN (On-ChipfobO 1:, 0:L)
     +-- RSTDISBL (RESETs 1:L, 0:(PC6))

Ext: -----001 (F9)
          ||+-- BOOTRST f[^V[gQ
          ++-- BOOTSZ[1:0] f[^V[gQ
*/

//ATtiny2313
/*
y|[gΉz	ATtiny2313	x:݂Ȃ(PA2RESET) -:
bit		7	6	5	4	3	2	1	0
portA	x	x	x	x	x	x	Xtl	Xtl		NX^
portB	-	-	-	-	-	-	-	-		--
portD	-	-	-	-	D+	D-	-	-		--

yATtiny2313z
|-BBBBBBBBD|
|V765432106|
>          |
|201102345G|
|ADDAADDDD-|

yq[Yrbgz(ftavrw.exe -rf)	Hoאݒ Low:01100100(64), Hi:11011111(DF)
[vusb-20120109/examples/hid-data/firmware/Makefile]Q
Low: 11101111 (EF)
     ||||++++-- CKSEL[3:0] VXeNbNI
     ||++-- SUT[1:0] N
     |+-- CKOUT (0:PD2ɃVXeNbNo)
     +-- CKDIV8 NbNl (1:1/1, 0:1/8)

High:11-11011 (DB)
     |||||||+-- RSTDISBL (RESETs 1:L, 0:(PA2))
     ||||+++-- BODLEVEL[2:0] (111:Off, 110:1.8, 101:2.7, 100:4.3)
     |||+-- WDTON (WDT 0:펞ON, 1:ʏ)
     ||+-- SPIEN (1:ISP֎~, 0:ISP) Parallel̂
     |+-- EESAVE (EEPROM 1:, 0:ێ)
     +-- DWEN (On-ChipfobO 1:, 0:L)

Ext: -------1 (FF)
            +-- SPMEN (SPM 1:, 0:L)
*/

/*
yrhz
Atmel AVR Studio 5 (Version: 5.1.208)	œKIvV: -Os
AVRGCC Version: 3.3.1.27
ATmega88P	12MHziNX^Uqj
ATtiny2313	12MHziNX^Uqj

yXVz
2012/04/01	v1.00	Program:    3132 bytes (76.5% Full)		ATmega48
					Program:    3136 bytes (38.3% Full)		ATmega88P
					Program:    3236 bytes (9.9% Full)		ATmega328P
					Data:         69 bytes (6.7% Full)
					
					Program:    2008 bytes (98.0% Full)		ATtiny2313
					Data:         53 bytes (41.4% Full)
*/

#include <avr/io.h>
#include <avr/wdt.h>
#include <avr/interrupt.h>
#include <util/delay.h>
#include <avr/eeprom.h>

#include <avr/pgmspace.h>
#include "usbdrv.h"

//yAVR-HID/IOz
//EEPROM16bitl̓ǂݏT|[g邩ǂ
#define HIDIO_USE_EEPROM_WORD	1	//1:ieʂɗ]TAVRj, 0:Ȃi]TȂAVRj
//C^vg](IN)gǂ
#define HIDIO_USE_INTRIN	USB_CFG_HAVE_INTRIN_ENDPOINT

/* ------------------------------------------------------------------------- */
/* ----------------------------- USB interface ----------------------------- */
/* ------------------------------------------------------------------------- */

PROGMEM char usbHidReportDescriptor[USB_CFG_HID_REPORT_DESCRIPTOR_LENGTH] =
{
    0x06, 0x00, 0xff,              // USAGE_PAGE (Vendor Defined Page 1)
    0x09, 0x01,                    // USAGE (Vendor Usage 1)
    0xa1, 0x01,                    // COLLECTION (Application)
    0x15, 0x00,                    //   LOGICAL_MINIMUM (0)
    0x26, 0xff, 0x00,              //   LOGICAL_MAXIMUM (255)
    0x75, 0x08,                    //   REPORT_SIZE (8) bit
	
    0x09, 0x00,                    //   USAGE (Undefined)
    0x95, 0x06,                    //   REPORT_COUNT (6)
    0xb1, 0x02,                    //   FEATURE (Data,Var,Abs)
	
#if HIDIO_USE_INTRIN
    0x09, 0x00,                    //   USAGE (Undefined)
    0x95, 0x04,                    //   REPORT_COUNT (4)
    0x81, 0x02,                    //   INPUT (Data,Var,Abs)
#endif
    
	0xc0                           // END_COLLECTION
};

/* ------------------------------------------------------------------------- */

#define CMD_BUF_SIZE	6
#define VECTOR_NUM_4BYTE	4
#define FEATURE_REPORT_SIZE	CMD_BUF_SIZE	//CMD_BUF_SIZEVECTOR_NUM_4BYTȆ傫
#define INPUT_REPORT_SIZE	VECTOR_NUM_4BYTE
static uint8_t	cmdBuf[CMD_BUF_SIZE];
static uint8_t	bufIndex;
static uint8_t	bytesRemaining;

enum Cmd
{
	//register operation
	CMD_GET,
	CMD_SET,
	CMD_AND,
	CMD_OR,
	CMD_XOR,
	
	//EEPROM operation
	CMD_READ_BYTE,
	CMD_WRITE_BYTE,
	CMD_READ_WORD,
	CMD_WRITE_WORD
};

enum CmdIdx
{
	//cmdBuf[0:Cmd][1:reg][2:value-Lo][3:value-Hi][4:adrs-Lo][5:adrs-Hi]
	ICmd = 0,
	IReg,
	IValL,	IVal8 = IValL,
	IValH,
	IAdrsL,
	IAdrsH
};

#if HIDIO_USE_INTRIN

static volatile uint8_t vectorNums[VECTOR_NUM_4BYTE];	//Ŝ32bit̃rbgtOƌ MSB[3][2][1][0]LSB
#define	SET_VECTOR_NUM(n)	{ vectorNums[(n) / 8] |= (1 << ((n) % 8)); }
#define isVectorNum()	(vectorNums[0] | vectorNums[1] | vectorNums[2] | vectorNums[3])	//1bitłĂtrue
#define clearVectorNum()	{ vectorNums[0] = vectorNums[1] = vectorNums[2] = vectorNums[3] = 0x00; }

//ATmega48/88/168/328
//(1)reset vector
//(2)INT0_vect	gps(USB D+)
//(3)INT1_vect	gps(USB D-)
ISR(PCINT0_vect) SET_VECTOR_NUM(4)
ISR(PCINT1_vect) SET_VECTOR_NUM(5)
ISR(PCINT2_vect) SET_VECTOR_NUM(6)
ISR(WDT_vect) SET_VECTOR_NUM(7)
ISR(TIMER2_COMPA_vect) SET_VECTOR_NUM(8)
ISR(TIMER2_COMPB_vect) SET_VECTOR_NUM(9)
ISR(TIMER2_OVF_vect) SET_VECTOR_NUM(10)
ISR(TIMER1_CAPT_vect) SET_VECTOR_NUM(11)
ISR(TIMER1_COMPA_vect) SET_VECTOR_NUM(12)
ISR(TIMER1_COMPB_vect) SET_VECTOR_NUM(13)
ISR(TIMER1_OVF_vect) SET_VECTOR_NUM(14)
ISR(TIMER0_COMPA_vect) SET_VECTOR_NUM(15)
ISR(TIMER0_COMPB_vect) SET_VECTOR_NUM(16)
ISR(TIMER0_OVF_vect) SET_VECTOR_NUM(17)
ISR(SPI_STC_vect) SET_VECTOR_NUM(18)
ISR(USART_RX_vect) SET_VECTOR_NUM(19)
ISR(USART_UDRE_vect) SET_VECTOR_NUM(20)
ISR(USART_TX_vect) SET_VECTOR_NUM(21)
ISR(ADC_vect) SET_VECTOR_NUM(22)
ISR(EE_READY_vect) SET_VECTOR_NUM(23)
ISR(ANALOG_COMP_vect) SET_VECTOR_NUM(24)
ISR(TWI_vect) SET_VECTOR_NUM(25)
ISR(SPM_READY_vect) SET_VECTOR_NUM(26)

#endif

/* ------------------------------------------------------------------------- */

uchar   usbFunctionRead(uchar *data, uchar len)
{
	//feature|[g̓ǂݏoz肵ĂB
	//input|[gvꂽꍇ͖ӖȒlԂAō\ȂB
	
	uint8_t i;
	if(len > bytesRemaining) len = bytesRemaining;
    
	for (i = 0; i < len; i++)
		data[i] = cmdBuf[bufIndex + i];
	
    bufIndex += len;
    bytesRemaining -= len;
    return len;
}

uchar   usbFunctionWrite(uchar *data, uchar len)
{
	uint8_t i;
	volatile uint8_t *pReg;		//WX^͊mɔf悤volatile
	uint16_t adrs;
#if HIDIO_USE_EEPROM_WORD
	uint16_t nWord;
#endif
    
	if(bytesRemaining == 0) return 1;	//end of transfer
    if(len > bytesRemaining) len = bytesRemaining;
	
	for (i = 0; i < len; i++)
		cmdBuf[bufIndex + i] = data[i];
    
	bufIndex += len;
    bytesRemaining -= len;
	if (0 < bytesRemaining) return 0;	//return FALSE (data write continue)
	
	pReg = (uint8_t *)0 + cmdBuf[IReg];
	adrs = ((uint16_t)cmdBuf[IAdrsH] << 8) | (uint16_t)cmdBuf[IAdrsL];
	switch (cmdBuf[ICmd])
	{
	case CMD_GET:	cli();	cmdBuf[IVal8] = *pReg;	sei();	break;
	case CMD_SET:	cli();	*pReg = cmdBuf[IVal8];	sei();	break;
	case CMD_AND:	cli();	*pReg &= cmdBuf[IVal8];	sei();	break;
	case CMD_OR:	cli();	*pReg |= cmdBuf[IVal8];	sei();	break;
	case CMD_XOR:	cli();	*pReg ^= cmdBuf[IVal8];	sei();	break;
		
	case CMD_READ_BYTE:
		cmdBuf[IVal8] = eeprom_read_byte((uint8_t *)adrs);
		break;
		
	case CMD_WRITE_BYTE:
		eeprom_write_byte((uint8_t *)adrs, cmdBuf[IVal8]);
		break;
		
#if HIDIO_USE_EEPROM_WORD
	case CMD_READ_WORD:
		nWord = eeprom_read_word((uint16_t *)adrs);
		cmdBuf[IValL] = (uint8_t)(nWord & 0xFF);
		cmdBuf[IValH] = (uint8_t)((nWord >> 8) & 0xFF);
		break;
		
	case CMD_WRITE_WORD:
		nWord = ((uint16_t)cmdBuf[IValH] << 8) | (uint16_t)cmdBuf[IValL];
		eeprom_write_word((uint16_t *)adrs, nWord);
		break;
#endif
	default:	break;
	}
	
    return 1;	//return TRUE if this was the last chunk
}

/* ------------------------------------------------------------------------- */

//ReportType:input(1),output(2),feature(3)
#define USBHID_REPORTTYPE_INPUT		1
#define USBHID_REPORTTYPE_OUTPUT	2
#define USBHID_REPORTTYPE_FEATURE	3

usbMsgLen_t usbFunctionSetup(uchar data[8])
{
	usbRequest_t *rq = (void *)data;
	uint8_t	reportType;
	
	//HID class request
	//rq->wValue: ReportType (highbyte:[1]), ReportID (lowbyte:[0])
    if((rq->bmRequestType & USBRQ_TYPE_MASK) == USBRQ_TYPE_CLASS)
	{
		if(rq->bRequest == USBRQ_HID_GET_REPORT)
		{
            bufIndex = 0;
			bytesRemaining = 0;
			
			reportType = rq->wValue.bytes[1];
			if (reportType == USBHID_REPORTTYPE_FEATURE)
				bytesRemaining = FEATURE_REPORT_SIZE;
#if HIDIO_USE_INTRIN
			else if (reportType == USBHID_REPORTTYPE_INPUT)
				bytesRemaining = INPUT_REPORT_SIZE;
#endif
			if (0 < bytesRemaining) return USB_NO_MSG;
		}
		else if(rq->bRequest == USBRQ_HID_SET_REPORT)
		{
            bufIndex = 0;
			bytesRemaining = 0;
			
			reportType = rq->wValue.bytes[1];
			if (reportType == USBHID_REPORTTYPE_FEATURE)
				bytesRemaining = FEATURE_REPORT_SIZE;
			
			if (0 < bytesRemaining) return USB_NO_MSG;
		}
    }
	else
	{
        //ignore vendor type requests, we don't use any
    }
    return 0;
}

/* ------------------------------------------------------------------------- */

int main(void)
{
	uint8_t	i;
	
    wdt_enable(WDTO_1S);
	usbInit();
	
#if HIDIO_USE_INTRIN
	clearVectorNum();
#endif
	
	//enforce re-enumeration, do this while interrupts are disabled
	//fake USB disconnect for > 250 ms
	usbDeviceDisconnect();
	i = 0;
	while (--i)
	{
		wdt_reset();
		_delay_ms(1);
	}
	usbDeviceConnect();
	
	sei();
	while (1)
	{
		wdt_reset();
		usbPoll();
		
#if HIDIO_USE_INTRIN
		if(isVectorNum() && usbInterruptIsReady())
		{
			cli();
			usbSetInterrupt((uint8_t *)vectorNums, VECTOR_NUM_4BYTE);
			clearVectorNum();
			sei();
		}
#endif
    }
	
    return 0;
}
